Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3711)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3712)
@@ -806,12 +833,12 @@
         0.003_wp, 0.006_wp, 0.012_wp, 0.018_wp,                                & !parameter 67-70
         1736000.0_wp, 1736000.0_wp, 1736000.0_wp,                              & !parameter 71-73
-        0.037_wp, 0.037_wp, 0.037_wp, 0.8_wp, 0.6_wp,                             & !parameter 74-78
+        0.037_wp, 0.037_wp, 0.037_wp, 0.8_wp, 0.6_wp,                          & !parameter 74-78
         27.0_wp, 0.0_wp, 1.5_wp, 0.86_wp, 5.0_wp, 1.0_wp,                      & !parameter 79-84
         0.005_wp, 0.01_wp, 0.41_wp, 0.7_wp, 2000000.0_wp, 103000.0_wp,         & !parameter 85-90
         900000.0_wp, 0.35_wp, 0.14_wp, 0.035_wp, 0.93_wp, 27.0_wp, 0.0_wp,     & !parameter 91-97
         0.003_wp, 0.006_wp, 0.012_wp, 0.018_wp, 1736000.0_wp,                  & !parameter 98-102 
-        1736000.0_wp, 1736000.0_wp, 0.037_wp, 0.037_wp, 0.037_wp,                 & !parameter 103-107
+        1736000.0_wp, 1736000.0_wp, 0.037_wp, 0.037_wp, 0.037_wp,              & !parameter 103-107
         0.8_wp, 0.6_wp, 27.0_wp, 0.0_wp, 0.0_wp, 1.5_wp,                       & !parameter 108-113
-        0.86_wp, 5.0_wp, 0.0_wp,                                              & !parameter 114-116
+        0.86_wp, 5.0_wp, 0.0_wp,                                               & !parameter 114-116
         299.15_wp, 293.15_wp, 0.8_wp, 0.5_wp, 0.6_wp,                          & !parameter 117-121
         0.1_wp, 0.5_wp, 0.8_wp, 2.5_wp, 80000.0_wp, 4.5_wp,                    & !parameter 122-127
@@ -828,5 +855,5 @@
         0.57_wp, 0.57_wp, 0.57_wp, 0.91_wp,                                    & !parameter 41-44
         0.75_wp, 27.0_wp, 0.0_wp, 1.5_wp, 0.86_wp,                             & !parameter 45-49
-        5.0_wp, 0.001_wp, 0.0001_wp, 0.5_wp, 0.005_wp,                        & !parameter 50-54
+        5.0_wp, 0.001_wp, 0.0001_wp, 0.5_wp, 0.005_wp,                         & !parameter 50-54
         0.01_wp, 0.39_wp, 0.63_wp, 2200000.0_wp,                               & !parameter 55-58
         1400000.0_wp, 1300000.0_wp, 0.35_wp, 0.8_wp,                           & !parameter 59-62
@@ -841,5 +868,5 @@
         1736000.0_wp, 1736000.0_wp, 0.57_wp, 0.57_wp, 0.57_wp,                 & !parameter 103-107
         0.91_wp, 0.75_wp, 27.0_wp, 0.0_wp, 0.0_wp, 1.5_wp,                     & !parameter 108-113
-        0.86_wp, 5.0_wp, 0.0_wp,                                              & !parameter 114-116
+        0.86_wp, 5.0_wp, 0.0_wp,                                               & !parameter 114-116
         299.15_wp, 293.15_wp, 0.8_wp, 0.76_wp, 5.0_wp,                         & !parameter 117-121
         0.1_wp, 1.5_wp, 0.0_wp, 3.5_wp, 370000.0_wp, 4.5_wp,                   & !parameter 122-127
@@ -856,5 +883,5 @@
         0.11_wp, 0.11_wp, 0.11_wp, 0.87_wp,                                    & !parameter 41-44
         0.7_wp, 27.0_wp, 0.0_wp, 1.5_wp, 0.86_wp,                              & !parameter 45-49
-        5.0_wp, 0.001_wp, 0.0001_wp, 0.5_wp, 0.005_wp,                        & !parameter 50-54
+        5.0_wp, 0.001_wp, 0.0001_wp, 0.5_wp, 0.005_wp,                         & !parameter 50-54
         0.01_wp, 0.31_wp, 0.43_wp, 2000000.0_wp,                               & !parameter 55-58
         103000.0_wp, 900000.0_wp, 0.35_wp, 0.38_wp,                            & !parameter 59-62
@@ -869,5 +896,5 @@
         1736000.0_wp, 1736000.0_wp, 0.11_wp, 0.11_wp, 0.11_wp,                 & !parameter 103-107
         0.87_wp, 0.7_wp, 27.0_wp, 0.0_wp, 0.0_wp, 1.5_wp,                      & !parameter 108-113
-        0.86_wp, 5.0_wp, 0.0_wp,                                              & !parameter 114-116
+        0.86_wp, 5.0_wp, 0.0_wp,                                               & !parameter 114-116
         299.15_wp, 293.15_wp, 0.8_wp, 0.6_wp, 3.0_wp,                          & !parameter 117-121
         0.1_wp, 1.5_wp, 0.65_wp, 2.5_wp, 165000.0_wp, 4.5_wp,                  & !parameter 122-127
@@ -882,7 +909,7 @@
         27.0_wp, 0.525_wp, 0.003_wp, 0.006_wp, 0.012_wp, 0.018_wp,             & !parameter 32-37
         1736000.0_wp, 1736000.0_wp, 1736000.0_wp,                              & !parameter 38-40
-        0.037_wp, 0.037_wp, 0.037_wp, 0.8_wp,                                     & !parameter 41-44
+        0.037_wp, 0.037_wp, 0.037_wp, 0.8_wp,                                  & !parameter 41-44
         0.6_wp, 27.0_wp, 0.0_wp, 1.5_wp, 0.86_wp,                              & !parameter 45-49
-        5.0_wp, 0.001_wp, 0.0001_wp, 0.425_wp, 0.005_wp,                      & !parameter 50-54
+        5.0_wp, 0.001_wp, 0.0001_wp, 0.425_wp, 0.005_wp,                       & !parameter 50-54
         0.01_wp, 0.41_wp, 0.7_wp, 2000000.0_wp,                                & !parameter 55-58
         103000.0_wp, 900000.0_wp, 0.35_wp, 0.14_wp,                            & !parameter 59-62
@@ -890,12 +917,12 @@
         0.003_wp, 0.006_wp, 0.012_wp, 0.018_wp,                                & !parameter 67-70
         1736000.0_wp, 1736000.0_wp, 1736000.0_wp,                              & !parameter 71-73
-        0.037_wp, 0.037_wp, 0.037_wp, 0.8_wp, 0.6_wp,                             & !parameter 74-78
+        0.037_wp, 0.037_wp, 0.037_wp, 0.8_wp, 0.6_wp,                          & !parameter 74-78
         27.0_wp, 0.0_wp, 1.5_wp, 0.86_wp, 5.0_wp, 1.0_wp,                      & !parameter 79-84
         0.005_wp, 0.01_wp, 0.41_wp, 0.7_wp, 2000000.0_wp, 103000.0_wp,         & !parameter 85-90
         900000.0_wp, 0.35_wp, 0.14_wp, 0.035_wp, 0.91_wp, 27.0_wp, 0.0_wp,     & !parameter 91-97
         0.003_wp, 0.006_wp, 0.012_wp, 0.018_wp, 1736000.0_wp,                  & !parameter 98-102 
-        1736000.0_wp, 1736000.0_wp, 0.037_wp, 0.037_wp, 0.037_wp,                 & !parameter 103-107
+        1736000.0_wp, 1736000.0_wp, 0.037_wp, 0.037_wp, 0.037_wp,              & !parameter 103-107
         0.8_wp, 0.6_wp, 27.0_wp, 0.0_wp, 0.0_wp, 1.5_wp,                       & !parameter 108-113
-        0.86_wp, 5.0_wp, 0.0_wp,                                              & !parameter 114-116
+        0.86_wp, 5.0_wp, 0.0_wp,                                               & !parameter 114-116
         299.15_wp, 293.15_wp, 0.8_wp, 0.5_wp, 0.6_wp,                          & !parameter 117-121
         0.1_wp, 1.5_wp, 0.9_wp, 2.5_wp, 80000.0_wp, 4.5_wp,                    & !parameter 122-127
@@ -912,5 +939,5 @@
         0.57_wp, 0.57_wp, 0.57_wp, 0.8_wp,                                     & !parameter 41-44
         0.6_wp, 27.0_wp, 0.0_wp, 1.5_wp, 0.86_wp,                              & !parameter 45-49
-        5.0_wp, 0.001_wp, 0.0001_wp, 1.0_wp, 0.29_wp,                         & !parameter 50-54
+        5.0_wp, 0.001_wp, 0.0001_wp, 1.0_wp, 0.29_wp,                          & !parameter 50-54
         0.295_wp, 0.695_wp, 0.985_wp, 1950400.0_wp,                            & !parameter 55-58
         1848000.0_wp, 1848000.0_wp, 0.7_wp, 1.0_wp,                            & !parameter 59-62
@@ -925,5 +952,5 @@
         1736000.0_wp, 1736000.0_wp, 0.57_wp, 0.57_wp, 0.57_wp,                 & !parameter 103-107
         0.8_wp, 0.6_wp, 27.0_wp, 0.0_wp, 0.0_wp, 1.5_wp,                       & !parameter 108-113
-        0.86_wp, 5.0_wp, 0.0_wp,                                              & !parameter 114-116
+        0.86_wp, 5.0_wp, 0.0_wp,                                               & !parameter 114-116
         299.15_wp, 293.15_wp, 0.8_wp, 100.0_wp, 100.0_wp,                      & !parameter 117-121
         20.0_wp, 20.0_wp, 0.0_wp, 1.0_wp, 1.0_wp, 4.5_wp,                      & !parameter 122-127
@@ -944,36 +971,35 @@
 
     TYPE surf_type_usm
-       REAL(wp), DIMENSION(:),   ALLOCATABLE ::  var_usm_1d !< 1D prognostic variable
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_usm_2d !< 2D prognostic variable
+       REAL(wp), DIMENSION(:),   ALLOCATABLE ::  var_usm_1d  !< 1D prognostic variable
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  var_usm_2d  !< 2D prognostic variable
     END TYPE surf_type_usm
     
-    TYPE(surf_type_usm), POINTER  ::  m_liq_usm_h,        & !< liquid water reservoir (m), horizontal surface elements 
-                                      m_liq_usm_h_p         !< progn. liquid water reservoir (m), horizontal surface elements 
-
-    TYPE(surf_type_usm), TARGET   ::  m_liq_usm_h_1,      & !<
-                                      m_liq_usm_h_2         !<
-
-    TYPE(surf_type_usm), DIMENSION(:), POINTER  ::    &
-                                      m_liq_usm_v,        & !< liquid water reservoir (m), vertical surface elements 
-                                      m_liq_usm_v_p         !< progn. liquid water reservoir (m), vertical surface elements 
-
-    TYPE(surf_type_usm), DIMENSION(0:3), TARGET   ::  &
-                                      m_liq_usm_v_1,      & !<
-                                      m_liq_usm_v_2         !<
+    TYPE(surf_type_usm), POINTER  ::  m_liq_usm_h,        &  !< liquid water reservoir (m), horizontal surface elements 
+                                      m_liq_usm_h_p          !< progn. liquid water reservoir (m), horizontal surface elements 
+
+    TYPE(surf_type_usm), TARGET   ::  m_liq_usm_h_1,      &  !<
+                                      m_liq_usm_h_2          !<
+
+    TYPE(surf_type_usm), DIMENSION(:), POINTER  ::        &
+                                      m_liq_usm_v,        &  !< liquid water reservoir (m), vertical surface elements 
+                                      m_liq_usm_v_p          !< progn. liquid water reservoir (m), vertical surface elements 
+
+    TYPE(surf_type_usm), DIMENSION(0:3), TARGET   ::      &
+                                      m_liq_usm_v_1,      &  !<
+                                      m_liq_usm_v_2          !<
 
     TYPE(surf_type_usm), TARGET ::  tm_liq_usm_h_m      !< liquid water reservoir tendency (m), horizontal surface elements 
-    TYPE(surf_type_usm), DIMENSION(0:3), TARGET ::  tm_liq_usm_v_m      !< liquid water reservoir tendency (m), vertical surface elements 
-
-
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    TYPE(surf_type_usm), DIMENSION(0:3), TARGET ::  tm_liq_usm_v_m      !< liquid water reservoir tendency (m),
+                                                                        !< vertical surface elements
+
+!
 !-- anthropogenic heat sources
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE        ::  aheat             !< daily average of anthropogenic heat (W/m2)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheatprof         !< diurnal profiles of anthropogenic heat for particular layers
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          ::  aheatprof         !< diurnal profiles of anthropogenic heat
+                                                                         !< for particular layers
     INTEGER(iwp)                                   ::  naheatlayers = 1  !< number of layers of anthropogenic heat
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!
 !-- wall surface model
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !-- wall surface model constants
     INTEGER(iwp), PARAMETER                        :: nzb_wall = 0       !< inner side of the wall model (to be switched)
@@ -981,28 +1007,24 @@
     INTEGER(iwp), PARAMETER                        :: nzw = 4            !< number of wall layers (fixed for now)
 
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
-                                                                         !< normalized soil, wall and roof layer depths (m/m)
-!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default = (/0.33_wp, 0.66_wp, 1.0_wp /)
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.25_wp, 0.5_wp, 0.75_wp, 1.0_wp /)
-!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.33_wp, 0.66_wp, 1.0_wp /)
-!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
-                                                                         !< normalized window layer depths (m/m)
-!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
-                                                                         !< normalized green layer depths (m/m)
-    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.25_wp, 0.5_wp, 0.75_wp, 1.0_wp /)
-!    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green = (/0.33_wp, 0.66_wp, 1.0_wp /)
-
-
-    REAL(wp)                                       :: wall_inner_temperature = 295.0_wp    !< temperature of the inner wall surface (~22 degrees C) (K)
-    REAL(wp)                                       :: roof_inner_temperature = 295.0_wp    !< temperature of the inner roof surface (~22 degrees C) (K)
-    REAL(wp)                                       :: soil_inner_temperature = 288.0_wp    !< temperature of the deep soil (~15 degrees C) (K)
-    REAL(wp)                                       :: window_inner_temperature = 295.0_wp  !< temperature of the inner window surface (~22 degrees C) (K)
-
-    REAL(wp)                                       ::   m_total = 0.0_wp !< weighted total water content of the soil (m3/m3)
-    INTEGER(iwp)                                   ::   soil_type
-    
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default        = (/0.0242_wp, 0.0969_wp, 0.346_wp, 1.0_wp /)
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_window = (/0.25_wp,   0.5_wp,    0.75_wp,  1.0_wp /)
+    REAL(wp), DIMENSION(nzb_wall:nzt_wall)         :: zwn_default_green  = (/0.25_wp,   0.5_wp,    0.75_wp,  1.0_wp /)
+                                                                         !< normalized soil, wall and roof, window and
+                                                                         !<green layer depths (m/m)
+
+    REAL(wp)                                       :: wall_inner_temperature   = 295.0_wp    !< temperature of the inner wall
+                                                                                             !< surface (~22 degrees C) (K)
+    REAL(wp)                                       :: roof_inner_temperature   = 295.0_wp    !< temperature of the inner roof
+                                                                                             !< surface (~22 degrees C) (K)
+    REAL(wp)                                       :: soil_inner_temperature   = 288.0_wp    !< temperature of the deep soil
+                                                                                             !< (~15 degrees C) (K)
+    REAL(wp)                                       :: window_inner_temperature = 295.0_wp    !< temperature of the inner window
+                                                                                             !< surface (~22 degrees C) (K)
+
+    REAL(wp)                                       :: m_total = 0.0_wp  !< weighted total water content of the soil (m3/m3)
+    INTEGER(iwp)                                   :: soil_type
+
+!
 !-- surface and material model variables for walls, ground, roofs
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn                !< normalized wall layer depths (m)
     REAL(wp), DIMENSION(:), ALLOCATABLE            :: zwn_window         !< normalized window layer depths (m)
@@ -1023,10 +1045,10 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET    :: t_surf_green_h_2
 
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_wall_v
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_wall_v_p
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_window_v
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_window_v_p
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_green_v
-    TYPE(t_surf_vertical), DIMENSION(:), POINTER ::  t_surf_green_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_wall_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_wall_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_window_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_window_v_p
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_green_v
+    TYPE(t_surf_vertical), DIMENSION(:), POINTER   ::  t_surf_green_v_p
 
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_wall_v_1
@@ -1037,7 +1059,6 @@
     TYPE(t_surf_vertical), DIMENSION(0:3), TARGET  :: t_surf_green_v_2
 
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!
 !-- Energy balance variables
-!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !-- parameters of the land, roof and wall surfaces
 
@@ -1062,23 +1083,32 @@
     TYPE(t_wall_vertical), DIMENSION(0:3), TARGET  :: swc_v_1, swc_v_2
 
+!
 !-- Surface and material parameters classes (surface_type)
 !-- albedo, emissivity, lambda_surf, roughness, thickness, volumetric heat capacity, thermal conductivity
-    INTEGER(iwp)                                   :: n_surface_types      !< number of the wall type categories
-    INTEGER(iwp), PARAMETER                        :: n_surface_params = 9 !< number of parameters for each type of the wall
-    INTEGER(iwp), PARAMETER                        :: ialbedo  = 1         !< albedo of the surface
-    INTEGER(iwp), PARAMETER                        :: iemiss   = 2         !< emissivity of the surface
-    INTEGER(iwp), PARAMETER                        :: ilambdas = 3         !< heat conductivity lambda S between surface and material ( W m-2 K-1 )
-    INTEGER(iwp), PARAMETER                        :: irough   = 4         !< roughness length z0 for movements
-    INTEGER(iwp), PARAMETER                        :: iroughh  = 5         !< roughness length z0h for scalars (heat, humidity,...)
-    INTEGER(iwp), PARAMETER                        :: icsurf   = 6         !< Surface skin layer heat capacity (J m-2 K-1 )
-    INTEGER(iwp), PARAMETER                        :: ithick   = 7         !< thickness of the surface (wall, roof, land)  ( m )
-    INTEGER(iwp), PARAMETER                        :: irhoC    = 8         !< volumetric heat capacity rho*C of the material ( J m-3 K-1 )
-    INTEGER(iwp), PARAMETER                        :: ilambdah = 9         !< thermal conductivity lambda H of the wall (W m-1 K-1 )
-    CHARACTER(12), DIMENSION(:), ALLOCATABLE       :: surface_type_names   !< names of wall types (used only for reports)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        :: surface_type_codes   !< codes of wall types
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: surface_params       !< parameters of wall types
-
-    
+    INTEGER(iwp)                                   :: n_surface_types       !< number of the wall type categories
+    INTEGER(iwp), PARAMETER                        :: n_surface_params = 9  !< number of parameters for each type of the wall
+    INTEGER(iwp), PARAMETER                        :: ialbedo  = 1          !< albedo of the surface
+    INTEGER(iwp), PARAMETER                        :: iemiss   = 2          !< emissivity of the surface
+    INTEGER(iwp), PARAMETER                        :: ilambdas = 3          !< heat conductivity lambda S between surface
+                                                                            !< and material ( W m-2 K-1 )
+    INTEGER(iwp), PARAMETER                        :: irough   = 4          !< roughness length z0 for movements
+    INTEGER(iwp), PARAMETER                        :: iroughh  = 5          !< roughness length z0h for scalars
+                                                                            !< (heat, humidity,...)
+    INTEGER(iwp), PARAMETER                        :: icsurf   = 6          !< Surface skin layer heat capacity (J m-2 K-1 )
+    INTEGER(iwp), PARAMETER                        :: ithick   = 7          !< thickness of the surface (wall, roof, land)  ( m )
+    INTEGER(iwp), PARAMETER                        :: irhoC    = 8          !< volumetric heat capacity rho*C of
+                                                                            !< the material ( J m-3 K-1 )
+    INTEGER(iwp), PARAMETER                        :: ilambdah = 9          !< thermal conductivity lambda H
+                                                                            !< of the wall (W m-1 K-1 )
+    CHARACTER(12), DIMENSION(:), ALLOCATABLE       :: surface_type_names    !< names of wall types (used only for reports)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        :: surface_type_codes    !< codes of wall types
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE          :: surface_params        !< parameters of wall types
+
+!
 !-- interfaces of subroutines accessed from outside of this module
+    INTERFACE usm_3d_data_averaging
+       MODULE PROCEDURE usm_3d_data_averaging
+    END INTERFACE usm_3d_data_averaging
+
     INTERFACE usm_boundary_condition
        MODULE PROCEDURE usm_boundary_condition
@@ -1105,4 +1135,8 @@
     END INTERFACE usm_init
 
+    INTERFACE usm_init_arrays
+       MODULE PROCEDURE usm_init_arrays
+    END INTERFACE usm_init_arrays
+
     INTERFACE usm_material_heat_model
        MODULE PROCEDURE usm_material_heat_model
@@ -1133,29 +1167,23 @@
     END INTERFACE usm_wrd_local
 
-    INTERFACE usm_init_arrays
-       MODULE PROCEDURE usm_init_arrays
-    END INTERFACE usm_init_arrays
-
-    INTERFACE usm_3d_data_averaging
-       MODULE PROCEDURE usm_3d_data_averaging
-    END INTERFACE usm_3d_data_averaging
-
     
     SAVE
 
     PRIVATE 
-    
+
+!
 !-- Public functions
-    PUBLIC usm_boundary_condition, usm_check_parameters, usm_init,&
-           usm_rrd_local,                                                      & 
-           usm_surface_energy_balance, usm_material_heat_model,                &
-           usm_swap_timelevel, usm_check_data_output, usm_3d_data_averaging,   &
-           usm_data_output_3d, usm_define_netcdf_grid, usm_parin,              &
+    PUBLIC usm_boundary_condition, usm_check_parameters, usm_init,               &
+           usm_rrd_local,                                                        & 
+           usm_surface_energy_balance, usm_material_heat_model,                  &
+           usm_swap_timelevel, usm_check_data_output, usm_3d_data_averaging,     &
+           usm_data_output_3d, usm_define_netcdf_grid, usm_parin,                &
            usm_wrd_local, usm_init_arrays
 
+!
 !-- Public parameters, constants and initial values
-    PUBLIC usm_anthropogenic_heat, usm_material_model, usm_wall_mod,           &
-           usm_green_heat_model, building_pars,                                &
-           nzb_wall, nzt_wall, t_wall_h, t_wall_v,                             &
+    PUBLIC usm_anthropogenic_heat, usm_material_model, usm_wall_mod, &
+           usm_green_heat_model, building_pars,                      &
+           nzb_wall, nzt_wall, t_wall_h, t_wall_v,                   &
            t_window_h, t_window_v, building_type
 
@@ -1181,16 +1209,16 @@
 !--     Allocate radiation arrays which are part of the new data type. 
 !--     For horizontal surfaces.
-        ALLOCATE( surf_usm_h%surfhf(1:surf_usm_h%ns)    )
-        ALLOCATE( surf_usm_h%rad_net_l(1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%surfhf(1:surf_usm_h%ns)    )
+        ALLOCATE ( surf_usm_h%rad_net_l(1:surf_usm_h%ns) )
 !
 !--     For vertical surfaces
         DO  l = 0, 3
-           ALLOCATE( surf_usm_v(l)%surfhf(1:surf_usm_v(l)%ns)    )
-           ALLOCATE( surf_usm_v(l)%rad_net_l(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%surfhf(1:surf_usm_v(l)%ns)    )
+           ALLOCATE ( surf_usm_v(l)%rad_net_l(1:surf_usm_v(l)%ns) )
         ENDDO
 
+!
 !--     Wall surface model
 !--     allocate arrays for wall surface model and define pointers
-       
 !--     allocate array of wall types and wall parameters
         ALLOCATE ( surf_usm_h%surface_types(1:surf_usm_h%ns)      )
@@ -1200,5 +1228,5 @@
         surf_usm_h%building_type_name = 'none'
         DO  l = 0, 3
-           ALLOCATE( surf_usm_v(l)%surface_types(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%surface_types(1:surf_usm_v(l)%ns)      )
            ALLOCATE ( surf_usm_v(l)%building_type(1:surf_usm_v(l)%ns)      )
            ALLOCATE ( surf_usm_v(l)%building_type_name(1:surf_usm_v(l)%ns) )
@@ -1209,21 +1237,20 @@
 !--     Allocate albedo_type and albedo. Each surface element
 !--     has 3 values, 0: wall fraction, 1: green fraction, 2: window fraction.
-        ALLOCATE( surf_usm_h%albedo_type(0:2,1:surf_usm_h%ns) )
-        ALLOCATE( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)      )
+        ALLOCATE ( surf_usm_h%albedo_type(0:2,1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%albedo(0:2,1:surf_usm_h%ns)      )
         surf_usm_h%albedo_type = albedo_type
         DO  l = 0, 3
-           ALLOCATE( surf_usm_v(l)%albedo_type(0:2,1:surf_usm_v(l)%ns) )
-           ALLOCATE( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns)      )
+           ALLOCATE ( surf_usm_v(l)%albedo_type(0:2,1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%albedo(0:2,1:surf_usm_v(l)%ns)      )
            surf_usm_v(l)%albedo_type = albedo_type
         ENDDO       
 
-
 !
 !--     Allocate indoor target temperature for summer and winter
-        ALLOCATE( surf_usm_h%target_temp_summer(1:surf_usm_h%ns) )
-        ALLOCATE( surf_usm_h%target_temp_winter(1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%target_temp_summer(1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%target_temp_winter(1:surf_usm_h%ns) )
         DO  l = 0, 3
-           ALLOCATE( surf_usm_v(l)%target_temp_summer(1:surf_usm_v(l)%ns) )
-           ALLOCATE( surf_usm_v(l)%target_temp_winter(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%target_temp_summer(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%target_temp_winter(1:surf_usm_v(l)%ns) )
         ENDDO   
 !
@@ -1231,16 +1258,17 @@
         ALLOCATE ( surf_usm_h%ground_level(1:surf_usm_h%ns) ) 
         DO  l = 0, 3
-           ALLOCATE( surf_usm_v(l)%ground_level(1:surf_usm_v(l)%ns) )
+           ALLOCATE ( surf_usm_v(l)%ground_level(1:surf_usm_v(l)%ns) )
         ENDDO   
 !
 !--      Allocate arrays for relative surface fraction. 
 !--      0 - wall fraction, 1 - green fraction, 2 - window fraction
-         ALLOCATE( surf_usm_h%frac(0:2,1:surf_usm_h%ns) )
+         ALLOCATE ( surf_usm_h%frac(0:2,1:surf_usm_h%ns) )
          surf_usm_h%frac = 0.0_wp
          DO  l = 0, 3
-            ALLOCATE( surf_usm_v(l)%frac(0:2,1:surf_usm_v(l)%ns) )
+            ALLOCATE ( surf_usm_v(l)%frac(0:2,1:surf_usm_v(l)%ns) )
             surf_usm_v(l)%frac = 0.0_wp
          ENDDO
-       
+
+!
 !--     wall and roof surface parameters. First for horizontal surfaces
         ALLOCATE ( surf_usm_h%isroof_surf(1:surf_usm_h%ns)        )
@@ -1263,16 +1291,16 @@
 !--     For vertical surfaces.
         DO  l = 0, 3
-           ALLOCATE ( surf_usm_v(l)%lambda_surf(1:surf_usm_v(l)%ns)     )
-           ALLOCATE ( surf_usm_v(l)%c_surface(1:surf_usm_v(l)%ns)       )
+           ALLOCATE ( surf_usm_v(l)%lambda_surf(1:surf_usm_v(l)%ns)        )
+           ALLOCATE ( surf_usm_v(l)%c_surface(1:surf_usm_v(l)%ns)          )
            ALLOCATE ( surf_usm_v(l)%lambda_surf_window(1:surf_usm_v(l)%ns) )
            ALLOCATE ( surf_usm_v(l)%c_surface_window(1:surf_usm_v(l)%ns)   )
            ALLOCATE ( surf_usm_v(l)%lambda_surf_green(1:surf_usm_v(l)%ns)  )
            ALLOCATE ( surf_usm_v(l)%c_surface_green(1:surf_usm_v(l)%ns)    )
-           ALLOCATE ( surf_usm_v(l)%transmissivity(1:surf_usm_v(l)%ns)  )
-           ALLOCATE ( surf_usm_v(l)%lai(1:surf_usm_v(l)%ns)             )
-           ALLOCATE ( surf_usm_v(l)%emissivity(0:2,1:surf_usm_v(l)%ns)  )
-           ALLOCATE ( surf_usm_v(l)%r_a(1:surf_usm_v(l)%ns)             )
-           ALLOCATE ( surf_usm_v(l)%r_a_green(1:surf_usm_v(l)%ns)       )
-           ALLOCATE ( surf_usm_v(l)%r_a_window(1:surf_usm_v(l)%ns)      )           
+           ALLOCATE ( surf_usm_v(l)%transmissivity(1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%lai(1:surf_usm_v(l)%ns)                )
+           ALLOCATE ( surf_usm_v(l)%emissivity(0:2,1:surf_usm_v(l)%ns)     )
+           ALLOCATE ( surf_usm_v(l)%r_a(1:surf_usm_v(l)%ns)                )
+           ALLOCATE ( surf_usm_v(l)%r_a_green(1:surf_usm_v(l)%ns)          )
+           ALLOCATE ( surf_usm_v(l)%r_a_window(1:surf_usm_v(l)%ns)         )           
            ALLOCATE ( surf_usm_v(l)%r_s(1:surf_usm_v(l)%ns)                )
         ENDDO
@@ -1280,9 +1308,9 @@
 !       
 !--     allocate wall and roof material parameters. First for horizontal surfaces
-        ALLOCATE ( surf_usm_h%thickness_wall(1:surf_usm_h%ns)               )
+        ALLOCATE ( surf_usm_h%thickness_wall(1:surf_usm_h%ns)                    )
         ALLOCATE ( surf_usm_h%thickness_window(1:surf_usm_h%ns)                  )
         ALLOCATE ( surf_usm_h%thickness_green(1:surf_usm_h%ns)                   )
-        ALLOCATE ( surf_usm_h%lambda_h(nzb_wall:nzt_wall,1:surf_usm_h%ns)   )
-        ALLOCATE ( surf_usm_h%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
+        ALLOCATE ( surf_usm_h%lambda_h(nzb_wall:nzt_wall,1:surf_usm_h%ns)        )
+        ALLOCATE ( surf_usm_h%rho_c_wall(nzb_wall:nzt_wall,1:surf_usm_h%ns)      )
         ALLOCATE ( surf_usm_h%lambda_h_window(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
         ALLOCATE ( surf_usm_h%rho_c_window(nzb_wall:nzt_wall,1:surf_usm_h%ns)    )
